const defaultOptions = {
    elementSeparator: '__',
    modifierSeparator: '--',
};
export function bemJoin(blockNameOrOptions = {}) {
    return typeof blockNameOrOptions === 'string'
        ? bemJoinOptions(defaultOptions)(blockNameOrOptions)
        : bemJoinOptions({
            ...defaultOptions,
            ...blockNameOrOptions,
        });
    function bemJoinOptions(options) {
        return (blockName) => (blockModifiersOrElementName, elementModifiers = {}) => (typeof blockModifiersOrElementName === 'string'
            ? joinBEMModifiers([blockName, blockModifiersOrElementName].join(options.elementSeparator), elementModifiers, options.modifierSeparator)
            : joinBEMModifiers(blockName, blockModifiersOrElementName, options.modifierSeparator)).join(' ');
        function joinBEMModifiers(blockOrElement, modifiers = {}, separator) {
            return [blockOrElement].concat(Object.keys(modifiers)
                .filter(m => modifiers[m])
                .map(m => [blockOrElement, m].join(separator)));
        }
    }
}
